%ext ck4
%version 1.4

###########################
# The Usual Junk Required #
###########################

# Load the modified graphics please
%egahead EGAHEAD.CK4

# Load the maps now
%maphead maphead.ck4

# Load the tile properties thanks
%patchfile $249C2 keen4.tli

# Star wars text cheers
%patchfile $1EE40 "STORY.CK4"

############################
# Miscellaneous            #
############################
# Level Related #
#################

#Bridge thickness - Keen 4
%patch $C1F2 $0004W

#########
# Other #
#########

############################
# Level Names and Entries  #
############################

#Level 1 name
%level.name 1 Pelagic Pillars
#Level 1 entry text
%level.entry 1 Keen dangles on
Pelagic Pillars

################
#              #
# Text Patches #
#              #
################


################################
# Dorsal Relics (Member texts) #
################################


####################
# Dorsal (Lindsey) #
####################


#########################
#                       #
# ENEMY RELATED PATCHES #
#                       #
#########################


#############
# Inch Worm #
#############

#Inchworm Speed
%patch $31D16 $0100W $0000W #Speed 1
%patch $31D34 $0100W $0000W #Speed 2

#Keen appears in front of Inchworm
%patch $10ED0 $0000W #Inchworm

#Inchworm avoids keen (behavior code)
%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $D6 $A7 $3B $47
              $0A $76 $08 $C7 $44 $0E $0001W  $5E $5D $CB $C7 $44 $0E $FFFFW
              $5E $5D $CB



###########
# SkyPest #
###########

#Skypest don't land but slide along ground
%patch $10797 $2E

#Skypest can be stunned:
#New collision for Skypest, stunnable =$037D055ERL
%patch $3D2E $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
             $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
             $24C2W  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $24C2W
             $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

#Skypests use new collision
%patch $3130A $037D055ERL #Flying Skypest
%patch $31328 $037D055ERL #Flying Skypest

#Stunned Skypests act properly
%patch $31332 $01C8W $01C8W $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W


########
# Lick #
########

#Lick Foreground variable
%patch $112E6 $0000W

#Lick is deadly all the time, new collision
%patch $11423 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $12
              $B8 $312EW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $83 $6C
              $18 $10 $5F $5E $5D $CB

#Bouncing Lick uses this too
%patch $31E4A $10800C23RL #Lick bouncing
%patch $31E68 $10800C23RL #Lick bouncing
%patch $31E86 $10800C23RL #Lick bouncing
%patch $31EA4 $10800C23RL #Lick bouncing

#Lick movement code less flame checks (value FFB0 is jump height)
%patch $11342 $55 $8B $EC $83 $EC $02 $56 $57 $8B $76 $06 $8B $44 $0A $8B $1E #Check Keen's location
              $D6 $A7 $3B $47 $0A $76 $07 $C7 $44 $0E $FFFFW  $EB $05 $C7 $44 #Change H direction to follow him
              $0E $0001W  $8B $44 $0E $B1 $05 $D3 $E0 $89 $44 $16 $C7 $44 $18
              $FFB0W  $5F $5E $8B $E5 $5D $CB                                 #Large jump 


#############
# Berkeloid #
#############

#Berkeloid walks instead of floating
#patch $10DB5 $55 $8B $EC $56 $8B $76 $06 $FF $74 $20 $33 $C0 $50 $FF $74 $1E
              $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $16541641RL
              $83 $C4 $0C $5E $5D $CB

###########
# Mimrock #
###########

#Mimrock will never jump
%patch $11F43 $5E $5D $CB

#Mimrocks always pursue Keen
%patch $11EA6 $3458W  #Mimrocks spawned chasing Keen
%patch $322C6 $3458W  #If waiting, chase
%patch $3237A $3458W  #Mimrock doesn't slam back down, once activated.
%patch $11EEB $EB $04 #Ditch the first "Is Keen facing the Mimrock?" check
%patch $11F05 $EB $04 #Ditch the second "Is Keen facing the Mimrock?" check
%patch $11F3B $EB $06 #Don't make the Mimrock slam down if he spies Keen

#Mimrock foreground variable
%patch $11E85 $0001W

#############
# Berkeloid #
#############

#Berkeloid walks instead of floating
%patch $10DB5 $55 $8B $EC $56 $8B $76 $06 $FF $74 $20 $33 $C0 $50 $FF $74 $1E
              $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $16541641RL
              $83 $C4 $0C $5E $5D $CB

#############
# Blue Bird #
#############

#Walking birds (easy, medium, hard) are separate from flying birds
#Spawn points
%patch $EECB $1A84W #'I Keen' (Easy bird)
%patch $EECD $1A7DW #'Mom' (Normal bird)
%patch $EECF $1A76W #'Dad' (Hard bird)

#Initiation code at + $1A76
%patch $10366 $83 $3E $7A6CW  $03 $7C $19 $83 $3E $7A6CW  $02 $7C $12 $FF $76
              $FC $57 $9A $0FA808A1RL     $83 $C4 $04 $C7 $06 $5F $CB $0001W
              $E9 $EA74W

#Flying bird spawn code = $0FA808A1RL
%patch $10321 $55 $8B $EC $B8 $01 $00 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $1E $D8 $A7 $C7 $07 $001BW  $C7 $47 $02 $0001W  $C7 $47 $20 $0002W
                  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0
              $05 $FF1FW  $89 $47 $0C $B8 $224CW  $50 $53 $9A $09DC118CRL
              $83 $C4 $04 $5D $CB

#Stop the flying birds becoming walking birds:
%patch $103D0 $EB #Bird doesn't land when Keen is standing on ground level with it
%patch $1048B $EB #Don't land when Keen below it and Bird near ground

#Stop the walking birds flying or going to stunned bird
%patch $31026 $0173W $016FW $0000W $0000W $0001W $0078W $0080W $0000W #Waiting bird
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31044 $0173W $016FW $0000W $0000W $0001W $0007W $0080W $0000W #Walking birds
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31062 $0174W $0170W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $0FA804BERL   $09DC1795RL   $2210W
%patch $31080 $0175W $0171W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $0FA804BERL   $09DC1795RL   $222EW
%patch $3109E $0176W $0172W $0000W $0000W $0001W $0007W $0080W $0000W
              $10800770RL   $0FA804BERL   $09DC1795RL   $21D4W

#Eggs hatch to flying birds
%patch $10135 $224CW

#Stunned birds unstun to flying
%patch $311E6 $224CW

#Fix walking spawn height (Stop it floating in air)
%patch $1006A $FF1FW


###########
#Stun star#
###########

#Skypest: type 4
%patch $B7EE $19A8W

#Type 4 position
%patch $B768 $C7 $46 $FE $0040W  $BF $FF80W $EB $1C 

#Lick: type 5
%patch $B7FC $19B2W

#Type 5 position
%patch $B772 $C7 $46 $FE $0040W  $BF $FEA2W  $EB $12 


%dump d.beh
%end